import { StateMachineTransition } from "../common/StateMachineTransition";
import { DtoFieldMetadata } from "../dto/DtoMetadata";
export interface ModelFieldMetadata extends DtoFieldMetadata {
    /**
     * Default value for the field if not provided
     */
    defaultValue?: any;
    /**
     * Store time of creation
     */
    creationTimestamp?: boolean;
    /**
     * Store time of last modification
     */
    modificationTimestamp?: boolean;
    index?: {
        groups?: string[];
    };
    unique?: {
        groupName?: string;
    };
    /**
     * State machine to validate for transition.
     */
    stateMachineTransition?: StateMachineTransition<any>[];
    /**
     * Allow regex search in this field and other fields that has searchable is true.
     */
    searchable?: {
        /**
         * Case sensitive for searching.
         */
        caseSensitive?: boolean;
        /**
         * Accent sensitive for searching.
         */
        accentSensitive?: boolean;
    };
    /**
     * Whether this field value graphically represents the record
     */
    isLabel?: boolean;
}
